
const db = require('../models');
const FileDBApi = require('./file');
const crypto = require('crypto');
const Utils = require('../utils');



const Sequelize = db.Sequelize;
const Op = Sequelize.Op;

module.exports = class Billing_customersDBApi {
    

    
    static async create(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const billing_customers = await db.billing_customers.create(
            {
                id: data.id || undefined,
        
        provider: data.provider
        ||
        null
            ,
            
        provider_customer_ref: data.provider_customer_ref
        ||
        null
            ,
            
        default_currency: data.default_currency
        ||
        null
            ,
            
        linked_at: data.linked_at
        ||
        null
            ,
            
        is_active: data.is_active
        ||
        false
        
            ,
            
            importHash: data.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
    },
        { transaction },
    );

        
        await billing_customers.setUser( data.user || null, {
            transaction,
        });
        

        

        

        return billing_customers;
    }
    

    static async bulkImport(data, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        // Prepare data - wrapping individual data transformations in a map() method
        const billing_customersData = data.map((item, index) => ({
                id: item.id || undefined,
                
                provider: item.provider
            ||
            null
            ,
            
                provider_customer_ref: item.provider_customer_ref
            ||
            null
            ,
            
                default_currency: item.default_currency
            ||
            null
            ,
            
                linked_at: item.linked_at
            ||
            null
            ,
            
                is_active: item.is_active
            ||
            false
        
            ,
            
            importHash: item.importHash || null,
            createdById: currentUser.id,
            updatedById: currentUser.id,
            createdAt: new Date(Date.now() + index * 1000),
    }));

        // Bulk create items
        const billing_customers = await db.billing_customers.bulkCreate(billing_customersData, { transaction });

        // For each item created, replace relation files
        

        return billing_customers;
    }

    static async update(id, data,  options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;
        

        const billing_customers = await db.billing_customers.findByPk(id, {}, {transaction});


        

        const updatePayload = {};
        
        if (data.provider !== undefined) updatePayload.provider = data.provider;
        
        
        if (data.provider_customer_ref !== undefined) updatePayload.provider_customer_ref = data.provider_customer_ref;
        
        
        if (data.default_currency !== undefined) updatePayload.default_currency = data.default_currency;
        
        
        if (data.linked_at !== undefined) updatePayload.linked_at = data.linked_at;
        
        
        if (data.is_active !== undefined) updatePayload.is_active = data.is_active;
        
        
        updatePayload.updatedById = currentUser.id;

        await billing_customers.update(updatePayload, {transaction});

        
        
        if (data.user !== undefined) {
            await billing_customers.setUser(
              
              data.user,
              
              { transaction }
            );
        }
        

        
        

        

        return billing_customers;
    }

    static async deleteByIds(ids, options) {
        const currentUser = (options && options.currentUser) || { id: null };
        const transaction = (options && options.transaction) || undefined;

        const billing_customers = await db.billing_customers.findAll({
            where: {
                id: {
                    [Op.in]: ids,
                },
            },
            transaction,
        });

        await db.sequelize.transaction(async (transaction) => {
            for (const record of billing_customers) {
                await record.update(
                    {deletedBy: currentUser.id},
                    {transaction}
                );
            }
            for (const record of billing_customers) {
                await record.destroy({transaction});
            }
        });


        return billing_customers;
    }

    static async remove(id, options) {
        const currentUser = (options && options.currentUser) || {id: null};
        const transaction = (options && options.transaction) || undefined;

        const billing_customers = await db.billing_customers.findByPk(id, options);

        await billing_customers.update({
            deletedBy: currentUser.id
        }, {
            transaction,
        });

        await billing_customers.destroy({
            transaction
        });

        return billing_customers;
    }

    static async findBy(where, options) {
        const transaction = (options && options.transaction) || undefined;

        const billing_customers = await db.billing_customers.findOne(
            { where },
            { transaction },
        );

        if (!billing_customers) {
            return billing_customers;
        }

        const output = billing_customers.get({plain: true});

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        output.user = await billing_customers.getUser({
            transaction
        });
        
        

        return output;
    }

    static async findAll(
          filter,
           options
        ) {
        const limit = filter.limit || 0;
        let offset = 0;
        let where = {};
        const currentPage = +filter.page;

        

        

        offset = currentPage * limit;

        const orderBy = null;

    const transaction = (options && options.transaction) || undefined;

    let include = [

      {
        model: db.users,
        as: 'user',
        
        where: filter.user ? {
          [Op.or]: [
            { id: { [Op.in]: filter.user.split('|').map(term => Utils.uuid(term)) } },
            {
              firstName: {
                [Op.or]: filter.user.split('|').map(term => ({ [Op.iLike]: `%${term}%` }))
              }
            },
          ]
        } : {},
        
      },



    ];

        if (filter) {
            if (filter.id) {
                where = {
                    ...where,
                    ['id']: Utils.uuid(filter.id),
                };
            }

            
            if (filter.provider) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'billing_customers',
                        'provider',
                        filter.provider,
                    ),
                };
            }
            
            if (filter.provider_customer_ref) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'billing_customers',
                        'provider_customer_ref',
                        filter.provider_customer_ref,
                    ),
                };
            }
            
            if (filter.default_currency) {
                where = {
                    ...where,
                    [Op.and]: Utils.ilike(
                        'billing_customers',
                        'default_currency',
                        filter.default_currency,
                    ),
                };
            }
            

            
            

            
            if (filter.linked_atRange) {
                const [start, end] = filter.linked_atRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                    linked_at: {
                    ...where.linked_at,
                            [Op.gte]: start,
                    },
                };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                    linked_at: {
                    ...where.linked_at,
                            [Op.lte]: end,
                    },
                };
                }
            }
            

            if (filter.active !== undefined) {
                where = {
                    ...where,
                    active: filter.active === true || filter.active === 'true'
                };
            }

            
            if (filter.is_active) {
                where = {
                    ...where,
                is_active: filter.is_active,
            };
            }
            


      



            if (filter.createdAtRange) {
                const [start, end] = filter.createdAtRange;

                if (start !== undefined && start !== null && start !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.gte]: start,
                        },
                    };
                }

                if (end !== undefined && end !== null && end !== '') {
                    where = {
                        ...where,
                        ['createdAt']: {
                            ...where.createdAt,
                            [Op.lte]: end,
                        },
                    };
                }
            }
        }
        

        

        const queryOptions = {
            where,
            include,
            distinct: true,
            order: filter.field && filter.sort
                ? [[filter.field, filter.sort]]
                : [['createdAt', 'desc']],
            transaction: options?.transaction,
            logging: console.log
        };

        if (!options?.countOnly) {
            queryOptions.limit = limit ? Number(limit) : undefined;
            queryOptions.offset = offset ? Number(offset) : undefined;
        }

        try {
            const { rows, count } = await db.billing_customers.findAndCountAll(queryOptions);

            return {
                rows: options?.countOnly ? [] : rows,
                count: count
            };
        } catch (error) {
            console.error('Error executing query:', error);
            throw error;
        }
    }

    static async findAllAutocomplete(query, limit, offset, ) {
        let where = {};
        
        

        if (query) {
            where = {
                [Op.or]: [
                    { ['id']: Utils.uuid(query) },
                    Utils.ilike(
                        'billing_customers',
                        'provider_customer_ref',
                        query,
                    ),
                ],
            };
        }

        const records = await db.billing_customers.findAll({
            attributes: [ 'id', 'provider_customer_ref' ],
            where,
            limit: limit ? Number(limit) : undefined,
            offset: offset ? Number(offset) : undefined,
            orderBy: [['provider_customer_ref', 'ASC']],
        });

        return records.map((record) => ({
            id: record.id,
            label: record.provider_customer_ref,
        }));
    }

    
};

